#region Copyright
/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////

#endregion

using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.IO;
using System.Linq;

namespace Dynastream.Fit
{
    /// <summary>
    /// Implements the HsaSpo2Data profile message.
    /// </summary>
    public class HsaSpo2DataMesg : Mesg
    {
        #region Fields
        #endregion

        /// <summary>
        /// Field Numbers for <see cref="HsaSpo2DataMesg"/>
        /// </summary>
        public sealed class FieldDefNum
        {
            public const byte Timestamp = 253;
            public const byte ProcessingInterval = 0;
            public const byte ReadingSpo2 = 1;
            public const byte Confidence = 2;
            public const byte Invalid = Fit.FieldNumInvalid;
        }

        #region Constructors
        public HsaSpo2DataMesg() : base(Profile.GetMesg(MesgNum.HsaSpo2Data))
        {
        }

        public HsaSpo2DataMesg(Mesg mesg) : base(mesg)
        {
        }
        #endregion // Constructors

        #region Methods
        ///<summary>
        /// Retrieves the Timestamp field
        /// Units: s</summary>
        /// <returns>Returns DateTime representing the Timestamp field</returns>
        public DateTime GetTimestamp()
        {
            Object val = GetFieldValue(253, 0, Fit.SubfieldIndexMainField);
            if(val == null)
            {
                return null;
            }

            return TimestampToDateTime(Convert.ToUInt32(val));
            
        }

        /// <summary>
        /// Set Timestamp field
        /// Units: s</summary>
        /// <param name="timestamp_">Nullable field value to be set</param>
        public void SetTimestamp(DateTime timestamp_)
        {
            SetFieldValue(253, 0, timestamp_.GetTimeStamp(), Fit.SubfieldIndexMainField);
        }
        
        ///<summary>
        /// Retrieves the ProcessingInterval field
        /// Units: s
        /// Comment: Processing interval length in seconds</summary>
        /// <returns>Returns nullable ushort representing the ProcessingInterval field</returns>
        public ushort? GetProcessingInterval()
        {
            Object val = GetFieldValue(0, 0, Fit.SubfieldIndexMainField);
            if(val == null)
            {
                return null;
            }

            return (Convert.ToUInt16(val));
            
        }

        /// <summary>
        /// Set ProcessingInterval field
        /// Units: s
        /// Comment: Processing interval length in seconds</summary>
        /// <param name="processingInterval_">Nullable field value to be set</param>
        public void SetProcessingInterval(ushort? processingInterval_)
        {
            SetFieldValue(0, 0, processingInterval_, Fit.SubfieldIndexMainField);
        }
        
        
        /// <summary>
        ///
        /// </summary>
        /// <returns>returns number of elements in field ReadingSpo2</returns>
        public int GetNumReadingSpo2()
        {
            return GetNumFieldValues(1, Fit.SubfieldIndexMainField);
        }

        ///<summary>
        /// Retrieves the ReadingSpo2 field
        /// Units: percent
        /// Comment: SpO2 Reading: [70,100] Blank: 240</summary>
        /// <param name="index">0 based index of ReadingSpo2 element to retrieve</param>
        /// <returns>Returns nullable byte representing the ReadingSpo2 field</returns>
        public byte? GetReadingSpo2(int index)
        {
            Object val = GetFieldValue(1, index, Fit.SubfieldIndexMainField);
            if(val == null)
            {
                return null;
            }

            return (Convert.ToByte(val));
            
        }

        /// <summary>
        /// Set ReadingSpo2 field
        /// Units: percent
        /// Comment: SpO2 Reading: [70,100] Blank: 240</summary>
        /// <param name="index">0 based index of reading_spo2</param>
        /// <param name="readingSpo2_">Nullable field value to be set</param>
        public void SetReadingSpo2(int index, byte? readingSpo2_)
        {
            SetFieldValue(1, index, readingSpo2_, Fit.SubfieldIndexMainField);
        }
        
        
        /// <summary>
        ///
        /// </summary>
        /// <returns>returns number of elements in field Confidence</returns>
        public int GetNumConfidence()
        {
            return GetNumFieldValues(2, Fit.SubfieldIndexMainField);
        }

        ///<summary>
        /// Retrieves the Confidence field
        /// Comment: SpO2 Confidence: [0,254]</summary>
        /// <param name="index">0 based index of Confidence element to retrieve</param>
        /// <returns>Returns nullable byte representing the Confidence field</returns>
        public byte? GetConfidence(int index)
        {
            Object val = GetFieldValue(2, index, Fit.SubfieldIndexMainField);
            if(val == null)
            {
                return null;
            }

            return (Convert.ToByte(val));
            
        }

        /// <summary>
        /// Set Confidence field
        /// Comment: SpO2 Confidence: [0,254]</summary>
        /// <param name="index">0 based index of confidence</param>
        /// <param name="confidence_">Nullable field value to be set</param>
        public void SetConfidence(int index, byte? confidence_)
        {
            SetFieldValue(2, index, confidence_, Fit.SubfieldIndexMainField);
        }
        
        #endregion // Methods
    } // Class
} // namespace
