/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


package com.garmin.fit;



public class SkinTempOvernightMesg extends Mesg   {

    
    public static final int TimestampFieldNum = 253;
    
    public static final int LocalTimestampFieldNum = 0;
    
    public static final int AverageDeviationFieldNum = 1;
    
    public static final int Average7DayDeviationFieldNum = 2;
    
    public static final int NightlyValueFieldNum = 4;
    

    protected static final  Mesg skinTempOvernightMesg;
    static {
        // skin_temp_overnight
        skinTempOvernightMesg = new Mesg("skin_temp_overnight", MesgNum.SKIN_TEMP_OVERNIGHT);
        skinTempOvernightMesg.addField(new Field("timestamp", TimestampFieldNum, 134, 1, 0, "", false, Profile.Type.DATE_TIME));
        
        skinTempOvernightMesg.addField(new Field("local_timestamp", LocalTimestampFieldNum, 134, 1, 0, "", false, Profile.Type.LOCAL_DATE_TIME));
        
        skinTempOvernightMesg.addField(new Field("average_deviation", AverageDeviationFieldNum, 136, 1, 0, "", false, Profile.Type.FLOAT32));
        
        skinTempOvernightMesg.addField(new Field("average_7_day_deviation", Average7DayDeviationFieldNum, 136, 1, 0, "", false, Profile.Type.FLOAT32));
        
        skinTempOvernightMesg.addField(new Field("nightly_value", NightlyValueFieldNum, 136, 1, 0, "", false, Profile.Type.FLOAT32));
        
    }

    public SkinTempOvernightMesg() {
        super(Factory.createMesg(MesgNum.SKIN_TEMP_OVERNIGHT));
    }

    public SkinTempOvernightMesg(final Mesg mesg) {
        super(mesg);
    }


    /**
     * Get timestamp field
     *
     * @return timestamp
     */
    public DateTime getTimestamp() {
        return timestampToDateTime(getFieldLongValue(253, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD));
    }

    /**
     * Set timestamp field
     *
     * @param timestamp The new timestamp value to be set
     */
    public void setTimestamp(DateTime timestamp) {
        setFieldValue(253, 0, timestamp.getTimestamp(), Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get local_timestamp field
     *
     * @return local_timestamp
     */
    public Long getLocalTimestamp() {
        return getFieldLongValue(0, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set local_timestamp field
     *
     * @param localTimestamp The new localTimestamp value to be set
     */
    public void setLocalTimestamp(Long localTimestamp) {
        setFieldValue(0, 0, localTimestamp, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get average_deviation field
     * Comment: The average overnight deviation from baseline temperature in degrees C
     *
     * @return average_deviation
     */
    public Float getAverageDeviation() {
        return getFieldFloatValue(1, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set average_deviation field
     * Comment: The average overnight deviation from baseline temperature in degrees C
     *
     * @param averageDeviation The new averageDeviation value to be set
     */
    public void setAverageDeviation(Float averageDeviation) {
        setFieldValue(1, 0, averageDeviation, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get average_7_day_deviation field
     * Comment: The average 7 day overnight deviation from baseline temperature in degrees C
     *
     * @return average_7_day_deviation
     */
    public Float getAverage7DayDeviation() {
        return getFieldFloatValue(2, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set average_7_day_deviation field
     * Comment: The average 7 day overnight deviation from baseline temperature in degrees C
     *
     * @param average7DayDeviation The new average7DayDeviation value to be set
     */
    public void setAverage7DayDeviation(Float average7DayDeviation) {
        setFieldValue(2, 0, average7DayDeviation, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get nightly_value field
     * Comment: Final overnight temperature value
     *
     * @return nightly_value
     */
    public Float getNightlyValue() {
        return getFieldFloatValue(4, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set nightly_value field
     * Comment: Final overnight temperature value
     *
     * @param nightlyValue The new nightlyValue value to be set
     */
    public void setNightlyValue(Float nightlyValue) {
        setFieldValue(4, 0, nightlyValue, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

}
