/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


import FIT from "./fit.js";

/**
 * The millisecond offset between UNIX and FIT Epochs (631065600000).
 * @const {number}
 */
const FIT_EPOCH_MS = 631065600000;

/**
 * Convert a FIT DateTime to a JavaScript Date
 * @param {number} datetime - Seconds since FIT EPOCH
 * @returns {Date} A JavaScript Date object
 */
const convertDateTimeToDate = (datetime) => {
    return new Date((datetime ?? 0) * 1000 + FIT_EPOCH_MS);
};

/**
 * Convert a JavaScript Date to a FIT DateTime
 * @param {Date} A JavaScript Date object
 * @return {number} datetime - Seconds since FIT EPOCH
 */
const convertDateToDateTime = (date) => {
    return (date.getTime() - FIT_EPOCH_MS) / 1000;
};

export default {
    FIT_EPOCH_MS,
    convertDateTimeToDate,
    convertDateToDateTime,
    FitBaseType: FIT.BaseType,
    BaseTypeToFieldType: FIT.BaseTypeToFieldType,
    FieldTypeToBaseType: FIT.FieldTypeToBaseType,
};
