/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


import Foundation

open class FitListener: MesgListener, DeveloperFieldDescriptionListener {
    open private(set) var fitMessages: FitMessages = FitMessages()
    
    public init() {
    }
    
    open func onMesg(_ mesg: Mesg) {
        switch mesg.mesgNum {
        case Profile.MesgNum.fileId:
            fitMessages.fileIdMesgs.append(FileIdMesg(mesg: mesg))
        case Profile.MesgNum.fileCreator:
            fitMessages.fileCreatorMesgs.append(FileCreatorMesg(mesg: mesg))
        case Profile.MesgNum.timestampCorrelation:
            fitMessages.timestampCorrelationMesgs.append(TimestampCorrelationMesg(mesg: mesg))
        case Profile.MesgNum.software:
            fitMessages.softwareMesgs.append(SoftwareMesg(mesg: mesg))
        case Profile.MesgNum.slaveDevice:
            fitMessages.slaveDeviceMesgs.append(SlaveDeviceMesg(mesg: mesg))
        case Profile.MesgNum.capabilities:
            fitMessages.capabilitiesMesgs.append(CapabilitiesMesg(mesg: mesg))
        case Profile.MesgNum.fileCapabilities:
            fitMessages.fileCapabilitiesMesgs.append(FileCapabilitiesMesg(mesg: mesg))
        case Profile.MesgNum.mesgCapabilities:
            fitMessages.mesgCapabilitiesMesgs.append(MesgCapabilitiesMesg(mesg: mesg))
        case Profile.MesgNum.fieldCapabilities:
            fitMessages.fieldCapabilitiesMesgs.append(FieldCapabilitiesMesg(mesg: mesg))
        case Profile.MesgNum.deviceSettings:
            fitMessages.deviceSettingsMesgs.append(DeviceSettingsMesg(mesg: mesg))
        case Profile.MesgNum.userProfile:
            fitMessages.userProfileMesgs.append(UserProfileMesg(mesg: mesg))
        case Profile.MesgNum.hrmProfile:
            fitMessages.hrmProfileMesgs.append(HrmProfileMesg(mesg: mesg))
        case Profile.MesgNum.sdmProfile:
            fitMessages.sdmProfileMesgs.append(SdmProfileMesg(mesg: mesg))
        case Profile.MesgNum.bikeProfile:
            fitMessages.bikeProfileMesgs.append(BikeProfileMesg(mesg: mesg))
        case Profile.MesgNum.connectivity:
            fitMessages.connectivityMesgs.append(ConnectivityMesg(mesg: mesg))
        case Profile.MesgNum.watchfaceSettings:
            fitMessages.watchfaceSettingsMesgs.append(WatchfaceSettingsMesg(mesg: mesg))
        case Profile.MesgNum.ohrSettings:
            fitMessages.ohrSettingsMesgs.append(OhrSettingsMesg(mesg: mesg))
        case Profile.MesgNum.timeInZone:
            fitMessages.timeInZoneMesgs.append(TimeInZoneMesg(mesg: mesg))
        case Profile.MesgNum.zonesTarget:
            fitMessages.zonesTargetMesgs.append(ZonesTargetMesg(mesg: mesg))
        case Profile.MesgNum.sport:
            fitMessages.sportMesgs.append(SportMesg(mesg: mesg))
        case Profile.MesgNum.hrZone:
            fitMessages.hrZoneMesgs.append(HrZoneMesg(mesg: mesg))
        case Profile.MesgNum.speedZone:
            fitMessages.speedZoneMesgs.append(SpeedZoneMesg(mesg: mesg))
        case Profile.MesgNum.cadenceZone:
            fitMessages.cadenceZoneMesgs.append(CadenceZoneMesg(mesg: mesg))
        case Profile.MesgNum.powerZone:
            fitMessages.powerZoneMesgs.append(PowerZoneMesg(mesg: mesg))
        case Profile.MesgNum.metZone:
            fitMessages.metZoneMesgs.append(MetZoneMesg(mesg: mesg))
        case Profile.MesgNum.trainingSettings:
            fitMessages.trainingSettingsMesgs.append(TrainingSettingsMesg(mesg: mesg))
        case Profile.MesgNum.diveSettings:
            fitMessages.diveSettingsMesgs.append(DiveSettingsMesg(mesg: mesg))
        case Profile.MesgNum.diveAlarm:
            fitMessages.diveAlarmMesgs.append(DiveAlarmMesg(mesg: mesg))
        case Profile.MesgNum.diveApneaAlarm:
            fitMessages.diveApneaAlarmMesgs.append(DiveApneaAlarmMesg(mesg: mesg))
        case Profile.MesgNum.diveGas:
            fitMessages.diveGasMesgs.append(DiveGasMesg(mesg: mesg))
        case Profile.MesgNum.goal:
            fitMessages.goalMesgs.append(GoalMesg(mesg: mesg))
        case Profile.MesgNum.activity:
            fitMessages.activityMesgs.append(ActivityMesg(mesg: mesg))
        case Profile.MesgNum.session:
            fitMessages.sessionMesgs.append(SessionMesg(mesg: mesg))
        case Profile.MesgNum.lap:
            fitMessages.lapMesgs.append(LapMesg(mesg: mesg))
        case Profile.MesgNum.length:
            fitMessages.lengthMesgs.append(LengthMesg(mesg: mesg))
        case Profile.MesgNum.record:
            fitMessages.recordMesgs.append(RecordMesg(mesg: mesg))
        case Profile.MesgNum.event:
            fitMessages.eventMesgs.append(EventMesg(mesg: mesg))
        case Profile.MesgNum.deviceInfo:
            fitMessages.deviceInfoMesgs.append(DeviceInfoMesg(mesg: mesg))
        case Profile.MesgNum.deviceAuxBatteryInfo:
            fitMessages.deviceAuxBatteryInfoMesgs.append(DeviceAuxBatteryInfoMesg(mesg: mesg))
        case Profile.MesgNum.trainingFile:
            fitMessages.trainingFileMesgs.append(TrainingFileMesg(mesg: mesg))
        case Profile.MesgNum.weatherConditions:
            fitMessages.weatherConditionsMesgs.append(WeatherConditionsMesg(mesg: mesg))
        case Profile.MesgNum.weatherAlert:
            fitMessages.weatherAlertMesgs.append(WeatherAlertMesg(mesg: mesg))
        case Profile.MesgNum.gpsMetadata:
            fitMessages.gpsMetadataMesgs.append(GpsMetadataMesg(mesg: mesg))
        case Profile.MesgNum.cameraEvent:
            fitMessages.cameraEventMesgs.append(CameraEventMesg(mesg: mesg))
        case Profile.MesgNum.gyroscopeData:
            fitMessages.gyroscopeDataMesgs.append(GyroscopeDataMesg(mesg: mesg))
        case Profile.MesgNum.accelerometerData:
            fitMessages.accelerometerDataMesgs.append(AccelerometerDataMesg(mesg: mesg))
        case Profile.MesgNum.magnetometerData:
            fitMessages.magnetometerDataMesgs.append(MagnetometerDataMesg(mesg: mesg))
        case Profile.MesgNum.barometerData:
            fitMessages.barometerDataMesgs.append(BarometerDataMesg(mesg: mesg))
        case Profile.MesgNum.threeDSensorCalibration:
            fitMessages.threeDSensorCalibrationMesgs.append(ThreeDSensorCalibrationMesg(mesg: mesg))
        case Profile.MesgNum.oneDSensorCalibration:
            fitMessages.oneDSensorCalibrationMesgs.append(OneDSensorCalibrationMesg(mesg: mesg))
        case Profile.MesgNum.videoFrame:
            fitMessages.videoFrameMesgs.append(VideoFrameMesg(mesg: mesg))
        case Profile.MesgNum.obdiiData:
            fitMessages.obdiiDataMesgs.append(ObdiiDataMesg(mesg: mesg))
        case Profile.MesgNum.nmeaSentence:
            fitMessages.nmeaSentenceMesgs.append(NmeaSentenceMesg(mesg: mesg))
        case Profile.MesgNum.aviationAttitude:
            fitMessages.aviationAttitudeMesgs.append(AviationAttitudeMesg(mesg: mesg))
        case Profile.MesgNum.video:
            fitMessages.videoMesgs.append(VideoMesg(mesg: mesg))
        case Profile.MesgNum.videoTitle:
            fitMessages.videoTitleMesgs.append(VideoTitleMesg(mesg: mesg))
        case Profile.MesgNum.videoDescription:
            fitMessages.videoDescriptionMesgs.append(VideoDescriptionMesg(mesg: mesg))
        case Profile.MesgNum.videoClip:
            fitMessages.videoClipMesgs.append(VideoClipMesg(mesg: mesg))
        case Profile.MesgNum.set:
            fitMessages.setMesgs.append(SetMesg(mesg: mesg))
        case Profile.MesgNum.jump:
            fitMessages.jumpMesgs.append(JumpMesg(mesg: mesg))
        case Profile.MesgNum.split:
            fitMessages.splitMesgs.append(SplitMesg(mesg: mesg))
        case Profile.MesgNum.splitSummary:
            fitMessages.splitSummaryMesgs.append(SplitSummaryMesg(mesg: mesg))
        case Profile.MesgNum.climbPro:
            fitMessages.climbProMesgs.append(ClimbProMesg(mesg: mesg))
        case Profile.MesgNum.fieldDescription:
            fitMessages.fieldDescriptionMesgs.append(FieldDescriptionMesg(mesg: mesg))
        case Profile.MesgNum.developerDataId:
            fitMessages.developerDataIdMesgs.append(DeveloperDataIdMesg(mesg: mesg))
        case Profile.MesgNum.course:
            fitMessages.courseMesgs.append(CourseMesg(mesg: mesg))
        case Profile.MesgNum.coursePoint:
            fitMessages.coursePointMesgs.append(CoursePointMesg(mesg: mesg))
        case Profile.MesgNum.segmentId:
            fitMessages.segmentIdMesgs.append(SegmentIdMesg(mesg: mesg))
        case Profile.MesgNum.segmentLeaderboardEntry:
            fitMessages.segmentLeaderboardEntryMesgs.append(SegmentLeaderboardEntryMesg(mesg: mesg))
        case Profile.MesgNum.segmentPoint:
            fitMessages.segmentPointMesgs.append(SegmentPointMesg(mesg: mesg))
        case Profile.MesgNum.segmentLap:
            fitMessages.segmentLapMesgs.append(SegmentLapMesg(mesg: mesg))
        case Profile.MesgNum.segmentFile:
            fitMessages.segmentFileMesgs.append(SegmentFileMesg(mesg: mesg))
        case Profile.MesgNum.workout:
            fitMessages.workoutMesgs.append(WorkoutMesg(mesg: mesg))
        case Profile.MesgNum.workoutSession:
            fitMessages.workoutSessionMesgs.append(WorkoutSessionMesg(mesg: mesg))
        case Profile.MesgNum.workoutStep:
            fitMessages.workoutStepMesgs.append(WorkoutStepMesg(mesg: mesg))
        case Profile.MesgNum.exerciseTitle:
            fitMessages.exerciseTitleMesgs.append(ExerciseTitleMesg(mesg: mesg))
        case Profile.MesgNum.schedule:
            fitMessages.scheduleMesgs.append(ScheduleMesg(mesg: mesg))
        case Profile.MesgNum.totals:
            fitMessages.totalsMesgs.append(TotalsMesg(mesg: mesg))
        case Profile.MesgNum.weightScale:
            fitMessages.weightScaleMesgs.append(WeightScaleMesg(mesg: mesg))
        case Profile.MesgNum.bloodPressure:
            fitMessages.bloodPressureMesgs.append(BloodPressureMesg(mesg: mesg))
        case Profile.MesgNum.monitoringInfo:
            fitMessages.monitoringInfoMesgs.append(MonitoringInfoMesg(mesg: mesg))
        case Profile.MesgNum.monitoring:
            fitMessages.monitoringMesgs.append(MonitoringMesg(mesg: mesg))
        case Profile.MesgNum.monitoringHrData:
            fitMessages.monitoringHrDataMesgs.append(MonitoringHrDataMesg(mesg: mesg))
        case Profile.MesgNum.spo2Data:
            fitMessages.spo2DataMesgs.append(Spo2DataMesg(mesg: mesg))
        case Profile.MesgNum.hr:
            fitMessages.hrMesgs.append(HrMesg(mesg: mesg))
        case Profile.MesgNum.stressLevel:
            fitMessages.stressLevelMesgs.append(StressLevelMesg(mesg: mesg))
        case Profile.MesgNum.maxMetData:
            fitMessages.maxMetDataMesgs.append(MaxMetDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaBodyBatteryData:
            fitMessages.hsaBodyBatteryDataMesgs.append(HsaBodyBatteryDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaEvent:
            fitMessages.hsaEventMesgs.append(HsaEventMesg(mesg: mesg))
        case Profile.MesgNum.hsaAccelerometerData:
            fitMessages.hsaAccelerometerDataMesgs.append(HsaAccelerometerDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaGyroscopeData:
            fitMessages.hsaGyroscopeDataMesgs.append(HsaGyroscopeDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaStepData:
            fitMessages.hsaStepDataMesgs.append(HsaStepDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaSpo2Data:
            fitMessages.hsaSpo2DataMesgs.append(HsaSpo2DataMesg(mesg: mesg))
        case Profile.MesgNum.hsaStressData:
            fitMessages.hsaStressDataMesgs.append(HsaStressDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaRespirationData:
            fitMessages.hsaRespirationDataMesgs.append(HsaRespirationDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaHeartRateData:
            fitMessages.hsaHeartRateDataMesgs.append(HsaHeartRateDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaConfigurationData:
            fitMessages.hsaConfigurationDataMesgs.append(HsaConfigurationDataMesg(mesg: mesg))
        case Profile.MesgNum.hsaWristTemperatureData:
            fitMessages.hsaWristTemperatureDataMesgs.append(HsaWristTemperatureDataMesg(mesg: mesg))
        case Profile.MesgNum.memoGlob:
            fitMessages.memoGlobMesgs.append(MemoGlobMesg(mesg: mesg))
        case Profile.MesgNum.sleepLevel:
            fitMessages.sleepLevelMesgs.append(SleepLevelMesg(mesg: mesg))
        case Profile.MesgNum.antChannelId:
            fitMessages.antChannelIdMesgs.append(AntChannelIdMesg(mesg: mesg))
        case Profile.MesgNum.antRx:
            fitMessages.antRxMesgs.append(AntRxMesg(mesg: mesg))
        case Profile.MesgNum.antTx:
            fitMessages.antTxMesgs.append(AntTxMesg(mesg: mesg))
        case Profile.MesgNum.exdScreenConfiguration:
            fitMessages.exdScreenConfigurationMesgs.append(ExdScreenConfigurationMesg(mesg: mesg))
        case Profile.MesgNum.exdDataFieldConfiguration:
            fitMessages.exdDataFieldConfigurationMesgs.append(ExdDataFieldConfigurationMesg(mesg: mesg))
        case Profile.MesgNum.exdDataConceptConfiguration:
            fitMessages.exdDataConceptConfigurationMesgs.append(ExdDataConceptConfigurationMesg(mesg: mesg))
        case Profile.MesgNum.diveSummary:
            fitMessages.diveSummaryMesgs.append(DiveSummaryMesg(mesg: mesg))
        case Profile.MesgNum.aadAccelFeatures:
            fitMessages.aadAccelFeaturesMesgs.append(AadAccelFeaturesMesg(mesg: mesg))
        case Profile.MesgNum.hrv:
            fitMessages.hrvMesgs.append(HrvMesg(mesg: mesg))
        case Profile.MesgNum.beatIntervals:
            fitMessages.beatIntervalsMesgs.append(BeatIntervalsMesg(mesg: mesg))
        case Profile.MesgNum.hrvStatusSummary:
            fitMessages.hrvStatusSummaryMesgs.append(HrvStatusSummaryMesg(mesg: mesg))
        case Profile.MesgNum.hrvValue:
            fitMessages.hrvValueMesgs.append(HrvValueMesg(mesg: mesg))
        case Profile.MesgNum.rawBbi:
            fitMessages.rawBbiMesgs.append(RawBbiMesg(mesg: mesg))
        case Profile.MesgNum.respirationRate:
            fitMessages.respirationRateMesgs.append(RespirationRateMesg(mesg: mesg))
        case Profile.MesgNum.chronoShotSession:
            fitMessages.chronoShotSessionMesgs.append(ChronoShotSessionMesg(mesg: mesg))
        case Profile.MesgNum.chronoShotData:
            fitMessages.chronoShotDataMesgs.append(ChronoShotDataMesg(mesg: mesg))
        case Profile.MesgNum.tankUpdate:
            fitMessages.tankUpdateMesgs.append(TankUpdateMesg(mesg: mesg))
        case Profile.MesgNum.tankSummary:
            fitMessages.tankSummaryMesgs.append(TankSummaryMesg(mesg: mesg))
        case Profile.MesgNum.sleepAssessment:
            fitMessages.sleepAssessmentMesgs.append(SleepAssessmentMesg(mesg: mesg))
        case Profile.MesgNum.skinTempOvernight:
            fitMessages.skinTempOvernightMesgs.append(SkinTempOvernightMesg(mesg: mesg))
        case Profile.MesgNum.pad:
            fitMessages.padMesgs.append(PadMesg(mesg: mesg))
        default: break 
        }
    }

    open func onDescription(_ description: DeveloperFieldDescription) {
        fitMessages.developerFieldDescriptionMesgs.append(description)
    }
}