/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


import Foundation

public struct Factory {
    public static func getMesg(mesgNum: UInt16) -> Mesg {
        switch mesgNum {
		case Profile.MesgNum.fileId:
			return FileIdMesg.createFileIdMesg()
		case Profile.MesgNum.fileCreator:
			return FileCreatorMesg.createFileCreatorMesg()
		case Profile.MesgNum.timestampCorrelation:
			return TimestampCorrelationMesg.createTimestampCorrelationMesg()
		case Profile.MesgNum.software:
			return SoftwareMesg.createSoftwareMesg()
		case Profile.MesgNum.slaveDevice:
			return SlaveDeviceMesg.createSlaveDeviceMesg()
		case Profile.MesgNum.capabilities:
			return CapabilitiesMesg.createCapabilitiesMesg()
		case Profile.MesgNum.fileCapabilities:
			return FileCapabilitiesMesg.createFileCapabilitiesMesg()
		case Profile.MesgNum.mesgCapabilities:
			return MesgCapabilitiesMesg.createMesgCapabilitiesMesg()
		case Profile.MesgNum.fieldCapabilities:
			return FieldCapabilitiesMesg.createFieldCapabilitiesMesg()
		case Profile.MesgNum.deviceSettings:
			return DeviceSettingsMesg.createDeviceSettingsMesg()
		case Profile.MesgNum.userProfile:
			return UserProfileMesg.createUserProfileMesg()
		case Profile.MesgNum.hrmProfile:
			return HrmProfileMesg.createHrmProfileMesg()
		case Profile.MesgNum.sdmProfile:
			return SdmProfileMesg.createSdmProfileMesg()
		case Profile.MesgNum.bikeProfile:
			return BikeProfileMesg.createBikeProfileMesg()
		case Profile.MesgNum.connectivity:
			return ConnectivityMesg.createConnectivityMesg()
		case Profile.MesgNum.watchfaceSettings:
			return WatchfaceSettingsMesg.createWatchfaceSettingsMesg()
		case Profile.MesgNum.ohrSettings:
			return OhrSettingsMesg.createOhrSettingsMesg()
		case Profile.MesgNum.timeInZone:
			return TimeInZoneMesg.createTimeInZoneMesg()
		case Profile.MesgNum.zonesTarget:
			return ZonesTargetMesg.createZonesTargetMesg()
		case Profile.MesgNum.sport:
			return SportMesg.createSportMesg()
		case Profile.MesgNum.hrZone:
			return HrZoneMesg.createHrZoneMesg()
		case Profile.MesgNum.speedZone:
			return SpeedZoneMesg.createSpeedZoneMesg()
		case Profile.MesgNum.cadenceZone:
			return CadenceZoneMesg.createCadenceZoneMesg()
		case Profile.MesgNum.powerZone:
			return PowerZoneMesg.createPowerZoneMesg()
		case Profile.MesgNum.metZone:
			return MetZoneMesg.createMetZoneMesg()
		case Profile.MesgNum.trainingSettings:
			return TrainingSettingsMesg.createTrainingSettingsMesg()
		case Profile.MesgNum.diveSettings:
			return DiveSettingsMesg.createDiveSettingsMesg()
		case Profile.MesgNum.diveAlarm:
			return DiveAlarmMesg.createDiveAlarmMesg()
		case Profile.MesgNum.diveApneaAlarm:
			return DiveApneaAlarmMesg.createDiveApneaAlarmMesg()
		case Profile.MesgNum.diveGas:
			return DiveGasMesg.createDiveGasMesg()
		case Profile.MesgNum.goal:
			return GoalMesg.createGoalMesg()
		case Profile.MesgNum.activity:
			return ActivityMesg.createActivityMesg()
		case Profile.MesgNum.session:
			return SessionMesg.createSessionMesg()
		case Profile.MesgNum.lap:
			return LapMesg.createLapMesg()
		case Profile.MesgNum.length:
			return LengthMesg.createLengthMesg()
		case Profile.MesgNum.record:
			return RecordMesg.createRecordMesg()
		case Profile.MesgNum.event:
			return EventMesg.createEventMesg()
		case Profile.MesgNum.deviceInfo:
			return DeviceInfoMesg.createDeviceInfoMesg()
		case Profile.MesgNum.deviceAuxBatteryInfo:
			return DeviceAuxBatteryInfoMesg.createDeviceAuxBatteryInfoMesg()
		case Profile.MesgNum.trainingFile:
			return TrainingFileMesg.createTrainingFileMesg()
		case Profile.MesgNum.weatherConditions:
			return WeatherConditionsMesg.createWeatherConditionsMesg()
		case Profile.MesgNum.weatherAlert:
			return WeatherAlertMesg.createWeatherAlertMesg()
		case Profile.MesgNum.gpsMetadata:
			return GpsMetadataMesg.createGpsMetadataMesg()
		case Profile.MesgNum.cameraEvent:
			return CameraEventMesg.createCameraEventMesg()
		case Profile.MesgNum.gyroscopeData:
			return GyroscopeDataMesg.createGyroscopeDataMesg()
		case Profile.MesgNum.accelerometerData:
			return AccelerometerDataMesg.createAccelerometerDataMesg()
		case Profile.MesgNum.magnetometerData:
			return MagnetometerDataMesg.createMagnetometerDataMesg()
		case Profile.MesgNum.barometerData:
			return BarometerDataMesg.createBarometerDataMesg()
		case Profile.MesgNum.threeDSensorCalibration:
			return ThreeDSensorCalibrationMesg.createThreeDSensorCalibrationMesg()
		case Profile.MesgNum.oneDSensorCalibration:
			return OneDSensorCalibrationMesg.createOneDSensorCalibrationMesg()
		case Profile.MesgNum.videoFrame:
			return VideoFrameMesg.createVideoFrameMesg()
		case Profile.MesgNum.obdiiData:
			return ObdiiDataMesg.createObdiiDataMesg()
		case Profile.MesgNum.nmeaSentence:
			return NmeaSentenceMesg.createNmeaSentenceMesg()
		case Profile.MesgNum.aviationAttitude:
			return AviationAttitudeMesg.createAviationAttitudeMesg()
		case Profile.MesgNum.video:
			return VideoMesg.createVideoMesg()
		case Profile.MesgNum.videoTitle:
			return VideoTitleMesg.createVideoTitleMesg()
		case Profile.MesgNum.videoDescription:
			return VideoDescriptionMesg.createVideoDescriptionMesg()
		case Profile.MesgNum.videoClip:
			return VideoClipMesg.createVideoClipMesg()
		case Profile.MesgNum.set:
			return SetMesg.createSetMesg()
		case Profile.MesgNum.jump:
			return JumpMesg.createJumpMesg()
		case Profile.MesgNum.split:
			return SplitMesg.createSplitMesg()
		case Profile.MesgNum.splitSummary:
			return SplitSummaryMesg.createSplitSummaryMesg()
		case Profile.MesgNum.climbPro:
			return ClimbProMesg.createClimbProMesg()
		case Profile.MesgNum.fieldDescription:
			return FieldDescriptionMesg.createFieldDescriptionMesg()
		case Profile.MesgNum.developerDataId:
			return DeveloperDataIdMesg.createDeveloperDataIdMesg()
		case Profile.MesgNum.course:
			return CourseMesg.createCourseMesg()
		case Profile.MesgNum.coursePoint:
			return CoursePointMesg.createCoursePointMesg()
		case Profile.MesgNum.segmentId:
			return SegmentIdMesg.createSegmentIdMesg()
		case Profile.MesgNum.segmentLeaderboardEntry:
			return SegmentLeaderboardEntryMesg.createSegmentLeaderboardEntryMesg()
		case Profile.MesgNum.segmentPoint:
			return SegmentPointMesg.createSegmentPointMesg()
		case Profile.MesgNum.segmentLap:
			return SegmentLapMesg.createSegmentLapMesg()
		case Profile.MesgNum.segmentFile:
			return SegmentFileMesg.createSegmentFileMesg()
		case Profile.MesgNum.workout:
			return WorkoutMesg.createWorkoutMesg()
		case Profile.MesgNum.workoutSession:
			return WorkoutSessionMesg.createWorkoutSessionMesg()
		case Profile.MesgNum.workoutStep:
			return WorkoutStepMesg.createWorkoutStepMesg()
		case Profile.MesgNum.exerciseTitle:
			return ExerciseTitleMesg.createExerciseTitleMesg()
		case Profile.MesgNum.schedule:
			return ScheduleMesg.createScheduleMesg()
		case Profile.MesgNum.totals:
			return TotalsMesg.createTotalsMesg()
		case Profile.MesgNum.weightScale:
			return WeightScaleMesg.createWeightScaleMesg()
		case Profile.MesgNum.bloodPressure:
			return BloodPressureMesg.createBloodPressureMesg()
		case Profile.MesgNum.monitoringInfo:
			return MonitoringInfoMesg.createMonitoringInfoMesg()
		case Profile.MesgNum.monitoring:
			return MonitoringMesg.createMonitoringMesg()
		case Profile.MesgNum.monitoringHrData:
			return MonitoringHrDataMesg.createMonitoringHrDataMesg()
		case Profile.MesgNum.spo2Data:
			return Spo2DataMesg.createSpo2DataMesg()
		case Profile.MesgNum.hr:
			return HrMesg.createHrMesg()
		case Profile.MesgNum.stressLevel:
			return StressLevelMesg.createStressLevelMesg()
		case Profile.MesgNum.maxMetData:
			return MaxMetDataMesg.createMaxMetDataMesg()
		case Profile.MesgNum.hsaBodyBatteryData:
			return HsaBodyBatteryDataMesg.createHsaBodyBatteryDataMesg()
		case Profile.MesgNum.hsaEvent:
			return HsaEventMesg.createHsaEventMesg()
		case Profile.MesgNum.hsaAccelerometerData:
			return HsaAccelerometerDataMesg.createHsaAccelerometerDataMesg()
		case Profile.MesgNum.hsaGyroscopeData:
			return HsaGyroscopeDataMesg.createHsaGyroscopeDataMesg()
		case Profile.MesgNum.hsaStepData:
			return HsaStepDataMesg.createHsaStepDataMesg()
		case Profile.MesgNum.hsaSpo2Data:
			return HsaSpo2DataMesg.createHsaSpo2DataMesg()
		case Profile.MesgNum.hsaStressData:
			return HsaStressDataMesg.createHsaStressDataMesg()
		case Profile.MesgNum.hsaRespirationData:
			return HsaRespirationDataMesg.createHsaRespirationDataMesg()
		case Profile.MesgNum.hsaHeartRateData:
			return HsaHeartRateDataMesg.createHsaHeartRateDataMesg()
		case Profile.MesgNum.hsaConfigurationData:
			return HsaConfigurationDataMesg.createHsaConfigurationDataMesg()
		case Profile.MesgNum.hsaWristTemperatureData:
			return HsaWristTemperatureDataMesg.createHsaWristTemperatureDataMesg()
		case Profile.MesgNum.memoGlob:
			return MemoGlobMesg.createMemoGlobMesg()
		case Profile.MesgNum.sleepLevel:
			return SleepLevelMesg.createSleepLevelMesg()
		case Profile.MesgNum.antChannelId:
			return AntChannelIdMesg.createAntChannelIdMesg()
		case Profile.MesgNum.antRx:
			return AntRxMesg.createAntRxMesg()
		case Profile.MesgNum.antTx:
			return AntTxMesg.createAntTxMesg()
		case Profile.MesgNum.exdScreenConfiguration:
			return ExdScreenConfigurationMesg.createExdScreenConfigurationMesg()
		case Profile.MesgNum.exdDataFieldConfiguration:
			return ExdDataFieldConfigurationMesg.createExdDataFieldConfigurationMesg()
		case Profile.MesgNum.exdDataConceptConfiguration:
			return ExdDataConceptConfigurationMesg.createExdDataConceptConfigurationMesg()
		case Profile.MesgNum.diveSummary:
			return DiveSummaryMesg.createDiveSummaryMesg()
		case Profile.MesgNum.aadAccelFeatures:
			return AadAccelFeaturesMesg.createAadAccelFeaturesMesg()
		case Profile.MesgNum.hrv:
			return HrvMesg.createHrvMesg()
		case Profile.MesgNum.beatIntervals:
			return BeatIntervalsMesg.createBeatIntervalsMesg()
		case Profile.MesgNum.hrvStatusSummary:
			return HrvStatusSummaryMesg.createHrvStatusSummaryMesg()
		case Profile.MesgNum.hrvValue:
			return HrvValueMesg.createHrvValueMesg()
		case Profile.MesgNum.rawBbi:
			return RawBbiMesg.createRawBbiMesg()
		case Profile.MesgNum.respirationRate:
			return RespirationRateMesg.createRespirationRateMesg()
		case Profile.MesgNum.chronoShotSession:
			return ChronoShotSessionMesg.createChronoShotSessionMesg()
		case Profile.MesgNum.chronoShotData:
			return ChronoShotDataMesg.createChronoShotDataMesg()
		case Profile.MesgNum.tankUpdate:
			return TankUpdateMesg.createTankUpdateMesg()
		case Profile.MesgNum.tankSummary:
			return TankSummaryMesg.createTankSummaryMesg()
		case Profile.MesgNum.sleepAssessment:
			return SleepAssessmentMesg.createSleepAssessmentMesg()
		case Profile.MesgNum.skinTempOvernight:
			return SkinTempOvernightMesg.createSkinTempOvernightMesg()
		case Profile.MesgNum.pad:
			return PadMesg.createPadMesg()
        default:
            return createDefaultMesg(mesgName: "unknown", mesgNum: mesgNum)
        }
    }

    public static func createMesg(mesgNum: UInt16) -> Mesg {
        return getMesg(mesgNum: mesgNum)
    }

    public static func createDefaultMesg(mesgName: String, mesgNum: UInt16) -> Mesg {
        return Mesg(name: mesgName, num: mesgNum)
    }

    public static func createField(mesgNum: UInt16, fieldNum: UInt8) -> Field? {
            let mesg = getMesg(mesgNum: mesgNum)

            return mesg.getField(fieldNum: fieldNum)
        }

    public static func createDefaultField(fieldNum: UInt8, baseType: BaseType) -> Field {
        return Field(name: "unknown", num: fieldNum, type: baseType.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
    }
}
