/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class BarometerDataMesg : Mesg {
    public static let timestampFieldNum:UInt8 = 253
    public static let timestampMsFieldNum:UInt8 = 0
    public static let sampleTimeOffsetFieldNum:UInt8 = 1
    public static let baroPresFieldNum:UInt8 = 2

	public init() {
        super.init(mesg: BarometerDataMesg.createBarometerDataMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getTimestamp() -> DateTime? {
		guard let value = getFieldValue(fieldNum: BarometerDataMesg.timestampFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimestamp(_ value: DateTime) throws {
		try setFieldValue(fieldNum: BarometerDataMesg.timestampFieldNum, value: value.timestamp)
	}

	public func getTimestampMs() -> UInt16? {
		guard let value = getFieldValue(fieldNum: BarometerDataMesg.timestampMsFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return value
	}

	public func setTimestampMs(_ value: UInt16) throws {
		try setFieldValue(fieldNum: BarometerDataMesg.timestampMsFieldNum, value: value)
	}

	public func getNumSampleTimeOffset() -> UInt8 {
		guard let field = getField(fieldNum: BarometerDataMesg.sampleTimeOffsetFieldNum) else {
			return 0
		}

		return field.numValues
	}

	public func getSampleTimeOffset() -> [UInt16?]? {
		guard let field = getField(fieldNum: BarometerDataMesg.sampleTimeOffsetFieldNum) else {
			return nil
		}
		return field.toArray() as [UInt16?]
	}

	public func getSampleTimeOffset(index: Int) -> UInt16? {
		guard let value = getFieldValue(fieldNum: BarometerDataMesg.sampleTimeOffsetFieldNum, index: index) as? UInt16 else {
            return nil
        }
		return value
	}

	public func setSampleTimeOffset(index: Int, value: UInt16) throws {
		try setFieldValue(fieldNum: BarometerDataMesg.sampleTimeOffsetFieldNum, value: value, index: index)
	}

	public func getNumBaroPres() -> UInt8 {
		guard let field = getField(fieldNum: BarometerDataMesg.baroPresFieldNum) else {
			return 0
		}

		return field.numValues
	}

	public func getBaroPres() -> [UInt32?]? {
		guard let field = getField(fieldNum: BarometerDataMesg.baroPresFieldNum) else {
			return nil
		}
		return field.toArray() as [UInt32?]
	}

	public func getBaroPres(index: Int) -> UInt32? {
		guard let value = getFieldValue(fieldNum: BarometerDataMesg.baroPresFieldNum, index: index) as? UInt32 else {
            return nil
        }
		return value
	}

	public func setBaroPres(index: Int, value: UInt32) throws {
		try setFieldValue(fieldNum: BarometerDataMesg.baroPresFieldNum, value: value, index: index)
	}

	public class func createBarometerDataMesg() -> BarometerDataMesg {
        let mesg = BarometerDataMesg(name: "BarometerData", num: Profile.MesgNum.barometerData)
		
		mesg.fields[BarometerDataMesg.timestampFieldNum] = Field(name: "Timestamp", num: BarometerDataMesg.timestampFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[BarometerDataMesg.timestampMsFieldNum] = Field(name: "TimestampMs", num: BarometerDataMesg.timestampMsFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "ms", accumulated: false)
		mesg.fields[BarometerDataMesg.sampleTimeOffsetFieldNum] = Field(name: "SampleTimeOffset", num: BarometerDataMesg.sampleTimeOffsetFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "ms", accumulated: false)
		mesg.fields[BarometerDataMesg.baroPresFieldNum] = Field(name: "BaroPres", num: BarometerDataMesg.baroPresFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "Pa", accumulated: false)
        return mesg
    }
}