/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class CourseMesg : Mesg {
    public static let sportFieldNum:UInt8 = 4
    public static let nameFieldNum:UInt8 = 5
    public static let capabilitiesFieldNum:UInt8 = 6
    public static let subSportFieldNum:UInt8 = 7

	public init() {
        super.init(mesg: CourseMesg.createCourseMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getSport() -> Sport? {
		guard let value = getFieldValue(fieldNum: CourseMesg.sportFieldNum, index:0) as? UInt8 else {
            return nil
        }
		return Sport(rawValue: value) ?? .invalid
	}

	public func setSport(_ value: Sport) throws {
		try setFieldValue(fieldNum: CourseMesg.sportFieldNum, value: value.rawValue)
	}

	public func getName() -> String? {
		guard let value = getFieldValue(fieldNum: CourseMesg.nameFieldNum, index:0) as? String else {
            return nil
        }
		return value
	}

	public func setName(_ value: String) throws {
		try setFieldValue(fieldNum: CourseMesg.nameFieldNum, value: value)
	}

	public func getCapabilities() -> CourseCapabilities? {
		guard let value = getFieldValue(fieldNum: CourseMesg.capabilitiesFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return value
	}

	public func setCapabilities(_ value: CourseCapabilities) throws {
		try setFieldValue(fieldNum: CourseMesg.capabilitiesFieldNum, value: value)
	}

	public func getSubSport() -> SubSport? {
		guard let value = getFieldValue(fieldNum: CourseMesg.subSportFieldNum, index:0) as? UInt8 else {
            return nil
        }
		return SubSport(rawValue: value) ?? .invalid
	}

	public func setSubSport(_ value: SubSport) throws {
		try setFieldValue(fieldNum: CourseMesg.subSportFieldNum, value: value.rawValue)
	}

	public class func createCourseMesg() -> CourseMesg {
        let mesg = CourseMesg(name: "Course", num: Profile.MesgNum.course)
		
		mesg.fields[CourseMesg.sportFieldNum] = Field(name: "Sport", num: CourseMesg.sportFieldNum, type: BaseType.ENUM.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[CourseMesg.nameFieldNum] = Field(name: "Name", num: CourseMesg.nameFieldNum, type: BaseType.STRING.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[CourseMesg.capabilitiesFieldNum] = Field(name: "Capabilities", num: CourseMesg.capabilitiesFieldNum, type: BaseType.UINT32Z.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[CourseMesg.subSportFieldNum] = Field(name: "SubSport", num: CourseMesg.subSportFieldNum, type: BaseType.ENUM.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
        return mesg
    }
}