/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class HsaBodyBatteryDataMesg : Mesg {
    public static let timestampFieldNum:UInt8 = 253
    public static let processingIntervalFieldNum:UInt8 = 0
    public static let levelFieldNum:UInt8 = 1
    public static let chargedFieldNum:UInt8 = 2
    public static let unchargedFieldNum:UInt8 = 3

	public init() {
        super.init(mesg: HsaBodyBatteryDataMesg.createHsaBodyBatteryDataMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getTimestamp() -> DateTime? {
		guard let value = getFieldValue(fieldNum: HsaBodyBatteryDataMesg.timestampFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimestamp(_ value: DateTime) throws {
		try setFieldValue(fieldNum: HsaBodyBatteryDataMesg.timestampFieldNum, value: value.timestamp)
	}

	public func getProcessingInterval() -> UInt16? {
		guard let value = getFieldValue(fieldNum: HsaBodyBatteryDataMesg.processingIntervalFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return value
	}

	public func setProcessingInterval(_ value: UInt16) throws {
		try setFieldValue(fieldNum: HsaBodyBatteryDataMesg.processingIntervalFieldNum, value: value)
	}

	public func getNumLevel() -> UInt8 {
		guard let field = getField(fieldNum: HsaBodyBatteryDataMesg.levelFieldNum) else {
			return 0
		}

		return field.numValues
	}

	public func getLevel() -> [Int8?]? {
		guard let field = getField(fieldNum: HsaBodyBatteryDataMesg.levelFieldNum) else {
			return nil
		}
		return field.toArray() as [Int8?]
	}

	public func getLevel(index: Int) -> Int8? {
		guard let value = getFieldValue(fieldNum: HsaBodyBatteryDataMesg.levelFieldNum, index: index) as? Int8 else {
            return nil
        }
		return value
	}

	public func setLevel(index: Int, value: Int8) throws {
		try setFieldValue(fieldNum: HsaBodyBatteryDataMesg.levelFieldNum, value: value, index: index)
	}

	public func getNumCharged() -> UInt8 {
		guard let field = getField(fieldNum: HsaBodyBatteryDataMesg.chargedFieldNum) else {
			return 0
		}

		return field.numValues
	}

	public func getCharged() -> [Int16?]? {
		guard let field = getField(fieldNum: HsaBodyBatteryDataMesg.chargedFieldNum) else {
			return nil
		}
		return field.toArray() as [Int16?]
	}

	public func getCharged(index: Int) -> Int16? {
		guard let value = getFieldValue(fieldNum: HsaBodyBatteryDataMesg.chargedFieldNum, index: index) as? Int16 else {
            return nil
        }
		return value
	}

	public func setCharged(index: Int, value: Int16) throws {
		try setFieldValue(fieldNum: HsaBodyBatteryDataMesg.chargedFieldNum, value: value, index: index)
	}

	public func getNumUncharged() -> UInt8 {
		guard let field = getField(fieldNum: HsaBodyBatteryDataMesg.unchargedFieldNum) else {
			return 0
		}

		return field.numValues
	}

	public func getUncharged() -> [Int16?]? {
		guard let field = getField(fieldNum: HsaBodyBatteryDataMesg.unchargedFieldNum) else {
			return nil
		}
		return field.toArray() as [Int16?]
	}

	public func getUncharged(index: Int) -> Int16? {
		guard let value = getFieldValue(fieldNum: HsaBodyBatteryDataMesg.unchargedFieldNum, index: index) as? Int16 else {
            return nil
        }
		return value
	}

	public func setUncharged(index: Int, value: Int16) throws {
		try setFieldValue(fieldNum: HsaBodyBatteryDataMesg.unchargedFieldNum, value: value, index: index)
	}

	public class func createHsaBodyBatteryDataMesg() -> HsaBodyBatteryDataMesg {
        let mesg = HsaBodyBatteryDataMesg(name: "HsaBodyBatteryData", num: Profile.MesgNum.hsaBodyBatteryData)
		
		mesg.fields[HsaBodyBatteryDataMesg.timestampFieldNum] = Field(name: "Timestamp", num: HsaBodyBatteryDataMesg.timestampFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[HsaBodyBatteryDataMesg.processingIntervalFieldNum] = Field(name: "ProcessingInterval", num: HsaBodyBatteryDataMesg.processingIntervalFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[HsaBodyBatteryDataMesg.levelFieldNum] = Field(name: "Level", num: HsaBodyBatteryDataMesg.levelFieldNum, type: BaseType.SINT8.rawValue, scale: 1, offset: 0, units: "percent", accumulated: false)
		mesg.fields[HsaBodyBatteryDataMesg.chargedFieldNum] = Field(name: "Charged", num: HsaBodyBatteryDataMesg.chargedFieldNum, type: BaseType.SINT16.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[HsaBodyBatteryDataMesg.unchargedFieldNum] = Field(name: "Uncharged", num: HsaBodyBatteryDataMesg.unchargedFieldNum, type: BaseType.SINT16.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
        return mesg
    }
}