/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class HsaConfigurationDataMesg : Mesg {
    public static let timestampFieldNum:UInt8 = 253
    public static let dataFieldNum:UInt8 = 0
    public static let dataSizeFieldNum:UInt8 = 1

	public init() {
        super.init(mesg: HsaConfigurationDataMesg.createHsaConfigurationDataMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getTimestamp() -> DateTime? {
		guard let value = getFieldValue(fieldNum: HsaConfigurationDataMesg.timestampFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimestamp(_ value: DateTime) throws {
		try setFieldValue(fieldNum: HsaConfigurationDataMesg.timestampFieldNum, value: value.timestamp)
	}

	public func getNumData() -> UInt8 {
		guard let field = getField(fieldNum: HsaConfigurationDataMesg.dataFieldNum) else {
			return 0
		}

		return field.numValues
	}

	public func getData() -> [UInt8?]? {
		guard let field = getField(fieldNum: HsaConfigurationDataMesg.dataFieldNum) else {
			return nil
		}
		return field.toArray() as [UInt8?]
	}

	public func getData(index: Int) -> UInt8? {
		guard let value = getFieldValue(fieldNum: HsaConfigurationDataMesg.dataFieldNum, index: index) as? UInt8 else {
            return nil
        }
		return value
	}

	public func setData(index: Int, value: UInt8) throws {
		try setFieldValue(fieldNum: HsaConfigurationDataMesg.dataFieldNum, value: value, index: index)
	}

	public func getDataSize() -> UInt8? {
		guard let value = getFieldValue(fieldNum: HsaConfigurationDataMesg.dataSizeFieldNum, index:0) as? UInt8 else {
            return nil
        }
		return value
	}

	public func setDataSize(_ value: UInt8) throws {
		try setFieldValue(fieldNum: HsaConfigurationDataMesg.dataSizeFieldNum, value: value)
	}

	public class func createHsaConfigurationDataMesg() -> HsaConfigurationDataMesg {
        let mesg = HsaConfigurationDataMesg(name: "HsaConfigurationData", num: Profile.MesgNum.hsaConfigurationData)
		
		mesg.fields[HsaConfigurationDataMesg.timestampFieldNum] = Field(name: "Timestamp", num: HsaConfigurationDataMesg.timestampFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[HsaConfigurationDataMesg.dataFieldNum] = Field(name: "Data", num: HsaConfigurationDataMesg.dataFieldNum, type: BaseType.BYTE.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[HsaConfigurationDataMesg.dataSizeFieldNum] = Field(name: "DataSize", num: HsaConfigurationDataMesg.dataSizeFieldNum, type: BaseType.UINT8.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
        return mesg
    }
}