/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class HsaStepDataMesg : Mesg {
    public static let timestampFieldNum:UInt8 = 253
    public static let processingIntervalFieldNum:UInt8 = 0
    public static let stepsFieldNum:UInt8 = 1

	public init() {
        super.init(mesg: HsaStepDataMesg.createHsaStepDataMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getTimestamp() -> DateTime? {
		guard let value = getFieldValue(fieldNum: HsaStepDataMesg.timestampFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimestamp(_ value: DateTime) throws {
		try setFieldValue(fieldNum: HsaStepDataMesg.timestampFieldNum, value: value.timestamp)
	}

	public func getProcessingInterval() -> UInt16? {
		guard let value = getFieldValue(fieldNum: HsaStepDataMesg.processingIntervalFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return value
	}

	public func setProcessingInterval(_ value: UInt16) throws {
		try setFieldValue(fieldNum: HsaStepDataMesg.processingIntervalFieldNum, value: value)
	}

	public func getNumSteps() -> UInt8 {
		guard let field = getField(fieldNum: HsaStepDataMesg.stepsFieldNum) else {
			return 0
		}

		return field.numValues
	}

	public func getSteps() -> [UInt32?]? {
		guard let field = getField(fieldNum: HsaStepDataMesg.stepsFieldNum) else {
			return nil
		}
		return field.toArray() as [UInt32?]
	}

	public func getSteps(index: Int) -> UInt32? {
		guard let value = getFieldValue(fieldNum: HsaStepDataMesg.stepsFieldNum, index: index) as? UInt32 else {
            return nil
        }
		return value
	}

	public func setSteps(index: Int, value: UInt32) throws {
		try setFieldValue(fieldNum: HsaStepDataMesg.stepsFieldNum, value: value, index: index)
	}

	public class func createHsaStepDataMesg() -> HsaStepDataMesg {
        let mesg = HsaStepDataMesg(name: "HsaStepData", num: Profile.MesgNum.hsaStepData)
		
		mesg.fields[HsaStepDataMesg.timestampFieldNum] = Field(name: "Timestamp", num: HsaStepDataMesg.timestampFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[HsaStepDataMesg.processingIntervalFieldNum] = Field(name: "ProcessingInterval", num: HsaStepDataMesg.processingIntervalFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[HsaStepDataMesg.stepsFieldNum] = Field(name: "Steps", num: HsaStepDataMesg.stepsFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "steps", accumulated: false)
        return mesg
    }
}