/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class HsaStressDataMesg : Mesg {
    public static let timestampFieldNum:UInt8 = 253
    public static let processingIntervalFieldNum:UInt8 = 0
    public static let stressLevelFieldNum:UInt8 = 1

	public init() {
        super.init(mesg: HsaStressDataMesg.createHsaStressDataMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getTimestamp() -> DateTime? {
		guard let value = getFieldValue(fieldNum: HsaStressDataMesg.timestampFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimestamp(_ value: DateTime) throws {
		try setFieldValue(fieldNum: HsaStressDataMesg.timestampFieldNum, value: value.timestamp)
	}

	public func getProcessingInterval() -> UInt16? {
		guard let value = getFieldValue(fieldNum: HsaStressDataMesg.processingIntervalFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return value
	}

	public func setProcessingInterval(_ value: UInt16) throws {
		try setFieldValue(fieldNum: HsaStressDataMesg.processingIntervalFieldNum, value: value)
	}

	public func getNumStressLevel() -> UInt8 {
		guard let field = getField(fieldNum: HsaStressDataMesg.stressLevelFieldNum) else {
			return 0
		}

		return field.numValues
	}

	public func getStressLevel() -> [Int8?]? {
		guard let field = getField(fieldNum: HsaStressDataMesg.stressLevelFieldNum) else {
			return nil
		}
		return field.toArray() as [Int8?]
	}

	public func getStressLevel(index: Int) -> Int8? {
		guard let value = getFieldValue(fieldNum: HsaStressDataMesg.stressLevelFieldNum, index: index) as? Int8 else {
            return nil
        }
		return value
	}

	public func setStressLevel(index: Int, value: Int8) throws {
		try setFieldValue(fieldNum: HsaStressDataMesg.stressLevelFieldNum, value: value, index: index)
	}

	public class func createHsaStressDataMesg() -> HsaStressDataMesg {
        let mesg = HsaStressDataMesg(name: "HsaStressData", num: Profile.MesgNum.hsaStressData)
		
		mesg.fields[HsaStressDataMesg.timestampFieldNum] = Field(name: "Timestamp", num: HsaStressDataMesg.timestampFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[HsaStressDataMesg.processingIntervalFieldNum] = Field(name: "ProcessingInterval", num: HsaStressDataMesg.processingIntervalFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[HsaStressDataMesg.stressLevelFieldNum] = Field(name: "StressLevel", num: HsaStressDataMesg.stressLevelFieldNum, type: BaseType.SINT8.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
        return mesg
    }
}