/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class NmeaSentenceMesg : Mesg {
    public static let timestampFieldNum:UInt8 = 253
    public static let timestampMsFieldNum:UInt8 = 0
    public static let sentenceFieldNum:UInt8 = 1

	public init() {
        super.init(mesg: NmeaSentenceMesg.createNmeaSentenceMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getTimestamp() -> DateTime? {
		guard let value = getFieldValue(fieldNum: NmeaSentenceMesg.timestampFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimestamp(_ value: DateTime) throws {
		try setFieldValue(fieldNum: NmeaSentenceMesg.timestampFieldNum, value: value.timestamp)
	}

	public func getTimestampMs() -> UInt16? {
		guard let value = getFieldValue(fieldNum: NmeaSentenceMesg.timestampMsFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return value
	}

	public func setTimestampMs(_ value: UInt16) throws {
		try setFieldValue(fieldNum: NmeaSentenceMesg.timestampMsFieldNum, value: value)
	}

	public func getSentence() -> String? {
		guard let value = getFieldValue(fieldNum: NmeaSentenceMesg.sentenceFieldNum, index:0) as? String else {
            return nil
        }
		return value
	}

	public func setSentence(_ value: String) throws {
		try setFieldValue(fieldNum: NmeaSentenceMesg.sentenceFieldNum, value: value)
	}

	public class func createNmeaSentenceMesg() -> NmeaSentenceMesg {
        let mesg = NmeaSentenceMesg(name: "NmeaSentence", num: Profile.MesgNum.nmeaSentence)
		
		mesg.fields[NmeaSentenceMesg.timestampFieldNum] = Field(name: "Timestamp", num: NmeaSentenceMesg.timestampFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[NmeaSentenceMesg.timestampMsFieldNum] = Field(name: "TimestampMs", num: NmeaSentenceMesg.timestampMsFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "ms", accumulated: false)
		mesg.fields[NmeaSentenceMesg.sentenceFieldNum] = Field(name: "Sentence", num: NmeaSentenceMesg.sentenceFieldNum, type: BaseType.STRING.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
        return mesg
    }
}