/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class SlaveDeviceMesg : Mesg {
    public static let manufacturerFieldNum:UInt8 = 0
    public static let productFieldNum:UInt8 = 1

	private struct ProductSubField {
        public static let faveroProduct:UInt16 = 0
        public static let garminProduct:UInt16 = 1
        public static let subfields:UInt16 = 2
        public static let active:UInt16 = FIT.SUBFIELD_INDEX.ACTIVE_SUBFIELD
        public static let mainField:UInt16 = FIT.SUBFIELD_INDEX.MAIN_FIELD
    }

	public init() {
        super.init(mesg: SlaveDeviceMesg.createSlaveDeviceMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getManufacturer() -> Manufacturer? {
		guard let value = getFieldValue(fieldNum: SlaveDeviceMesg.manufacturerFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return Manufacturer(rawValue: value) ?? .invalid
	}

	public func setManufacturer(_ value: Manufacturer) throws {
		try setFieldValue(fieldNum: SlaveDeviceMesg.manufacturerFieldNum, value: value.rawValue)
	}

	public func getProduct() -> UInt16? {
		guard let value = getFieldValue(fieldNum: SlaveDeviceMesg.productFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return value
	}

	public func setProduct(_ value: UInt16) throws {
		try setFieldValue(fieldNum: SlaveDeviceMesg.productFieldNum, value: value)
	}

	public func getFaveroProduct() throws -> FaveroProduct? {
		guard let value = try getFieldValue(fieldNum: SlaveDeviceMesg.productFieldNum, index: 0, subFieldIndex: ProductSubField.faveroProduct).map({UInt16(fitValue: $0)}) else {
			return nil
		}
		
		return FaveroProduct(rawValue: value) ?? .invalid
	}

	public func setFaveroProduct(_ value: FaveroProduct) throws {
		try setFieldValue(fieldNum: SlaveDeviceMesg.productFieldNum, value: value.rawValue, index: 0, subFieldIndex: ProductSubField.faveroProduct )
	}

	public func getGarminProduct() throws -> GarminProduct? {
		guard let value = try getFieldValue(fieldNum: SlaveDeviceMesg.productFieldNum, index: 0, subFieldIndex: ProductSubField.garminProduct).map({UInt16(fitValue: $0)}) else {
			return nil
		}
		
		return GarminProduct(rawValue: value) ?? .invalid
	}

	public func setGarminProduct(_ value: GarminProduct) throws {
		try setFieldValue(fieldNum: SlaveDeviceMesg.productFieldNum, value: value.rawValue, index: 0, subFieldIndex: ProductSubField.garminProduct )
	}

	public class func createSlaveDeviceMesg() -> SlaveDeviceMesg {
        let mesg = SlaveDeviceMesg(name: "SlaveDevice", num: Profile.MesgNum.slaveDevice)
		
		mesg.fields[SlaveDeviceMesg.manufacturerFieldNum] = Field(name: "Manufacturer", num: SlaveDeviceMesg.manufacturerFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[SlaveDeviceMesg.productFieldNum] = Field(name: "Product", num: SlaveDeviceMesg.productFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
        mesg.fields[SlaveDeviceMesg.productFieldNum]?.subFields.append(SubField(name: "FaveroProduct", type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: ""))
        mesg.fields[SlaveDeviceMesg.productFieldNum]?.subFields[Int(ProductSubField.faveroProduct)].addMap(refFieldNum: 0, refFieldValue: 263)
        mesg.fields[SlaveDeviceMesg.productFieldNum]?.subFields.append(SubField(name: "GarminProduct", type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: ""))
        mesg.fields[SlaveDeviceMesg.productFieldNum]?.subFields[Int(ProductSubField.garminProduct)].addMap(refFieldNum: 0, refFieldValue: 1)
        mesg.fields[SlaveDeviceMesg.productFieldNum]?.subFields[Int(ProductSubField.garminProduct)].addMap(refFieldNum: 0, refFieldValue: 15)
        mesg.fields[SlaveDeviceMesg.productFieldNum]?.subFields[Int(ProductSubField.garminProduct)].addMap(refFieldNum: 0, refFieldValue: 13)
        mesg.fields[SlaveDeviceMesg.productFieldNum]?.subFields[Int(ProductSubField.garminProduct)].addMap(refFieldNum: 0, refFieldValue: 89)
        return mesg
    }
}