/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class TankSummaryMesg : Mesg {
    public static let timestampFieldNum:UInt8 = 253
    public static let sensorFieldNum:UInt8 = 0
    public static let startPressureFieldNum:UInt8 = 1
    public static let endPressureFieldNum:UInt8 = 2
    public static let volumeUsedFieldNum:UInt8 = 3

	public init() {
        super.init(mesg: TankSummaryMesg.createTankSummaryMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getTimestamp() -> DateTime? {
		guard let value = getFieldValue(fieldNum: TankSummaryMesg.timestampFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimestamp(_ value: DateTime) throws {
		try setFieldValue(fieldNum: TankSummaryMesg.timestampFieldNum, value: value.timestamp)
	}

	public func getSensor() -> AntChannelId? {
		guard let value = getFieldValue(fieldNum: TankSummaryMesg.sensorFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return value
	}

	public func setSensor(_ value: AntChannelId) throws {
		try setFieldValue(fieldNum: TankSummaryMesg.sensorFieldNum, value: value)
	}

	public func getStartPressure() -> Float64? {
		guard let value = getFieldValue(fieldNum: TankSummaryMesg.startPressureFieldNum, index:0) as? Float64 else {
            return nil
        }
		return value
	}

	public func setStartPressure(_ value: Float64) throws {
		try setFieldValue(fieldNum: TankSummaryMesg.startPressureFieldNum, value: value)
	}

	public func getEndPressure() -> Float64? {
		guard let value = getFieldValue(fieldNum: TankSummaryMesg.endPressureFieldNum, index:0) as? Float64 else {
            return nil
        }
		return value
	}

	public func setEndPressure(_ value: Float64) throws {
		try setFieldValue(fieldNum: TankSummaryMesg.endPressureFieldNum, value: value)
	}

	public func getVolumeUsed() -> Float64? {
		guard let value = getFieldValue(fieldNum: TankSummaryMesg.volumeUsedFieldNum, index:0) as? Float64 else {
            return nil
        }
		return value
	}

	public func setVolumeUsed(_ value: Float64) throws {
		try setFieldValue(fieldNum: TankSummaryMesg.volumeUsedFieldNum, value: value)
	}

	public class func createTankSummaryMesg() -> TankSummaryMesg {
        let mesg = TankSummaryMesg(name: "TankSummary", num: Profile.MesgNum.tankSummary)
		
		mesg.fields[TankSummaryMesg.timestampFieldNum] = Field(name: "Timestamp", num: TankSummaryMesg.timestampFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "s", accumulated: false)
		mesg.fields[TankSummaryMesg.sensorFieldNum] = Field(name: "Sensor", num: TankSummaryMesg.sensorFieldNum, type: BaseType.UINT32Z.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[TankSummaryMesg.startPressureFieldNum] = Field(name: "StartPressure", num: TankSummaryMesg.startPressureFieldNum, type: BaseType.UINT16.rawValue, scale: 100, offset: 0, units: "bar", accumulated: false)
		mesg.fields[TankSummaryMesg.endPressureFieldNum] = Field(name: "EndPressure", num: TankSummaryMesg.endPressureFieldNum, type: BaseType.UINT16.rawValue, scale: 100, offset: 0, units: "bar", accumulated: false)
		mesg.fields[TankSummaryMesg.volumeUsedFieldNum] = Field(name: "VolumeUsed", num: TankSummaryMesg.volumeUsedFieldNum, type: BaseType.UINT32.rawValue, scale: 100, offset: 0, units: "L", accumulated: false)
        return mesg
    }
}