/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2025 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.171.0Release
// Tag = production/release/21.171.0-0-g57fed75
/////////////////////////////////////////////////////////////////////////////////////////////


open class TrainingFileMesg : Mesg {
    public static let timestampFieldNum:UInt8 = 253
    public static let typeFieldNum:UInt8 = 0
    public static let manufacturerFieldNum:UInt8 = 1
    public static let productFieldNum:UInt8 = 2
    public static let serialNumberFieldNum:UInt8 = 3
    public static let timeCreatedFieldNum:UInt8 = 4

	private struct ProductSubField {
        public static let faveroProduct:UInt16 = 0
        public static let garminProduct:UInt16 = 1
        public static let subfields:UInt16 = 2
        public static let active:UInt16 = FIT.SUBFIELD_INDEX.ACTIVE_SUBFIELD
        public static let mainField:UInt16 = FIT.SUBFIELD_INDEX.MAIN_FIELD
    }

	public init() {
        super.init(mesg: TrainingFileMesg.createTrainingFileMesg())
    }

    public override init(mesg: Mesg) {
        super.init(mesg: mesg)
    }

    fileprivate override init(name: String, num: UInt16) {
        super.init(name: name, num: num)
    }

	public func getTimestamp() -> DateTime? {
		guard let value = getFieldValue(fieldNum: TrainingFileMesg.timestampFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimestamp(_ value: DateTime) throws {
		try setFieldValue(fieldNum: TrainingFileMesg.timestampFieldNum, value: value.timestamp)
	}

	public func getType() -> File? {
		guard let value = getFieldValue(fieldNum: TrainingFileMesg.typeFieldNum, index:0) as? UInt8 else {
            return nil
        }
		return File(rawValue: value) ?? .invalid
	}

	public func setType(_ value: File) throws {
		try setFieldValue(fieldNum: TrainingFileMesg.typeFieldNum, value: value.rawValue)
	}

	public func getManufacturer() -> Manufacturer? {
		guard let value = getFieldValue(fieldNum: TrainingFileMesg.manufacturerFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return Manufacturer(rawValue: value) ?? .invalid
	}

	public func setManufacturer(_ value: Manufacturer) throws {
		try setFieldValue(fieldNum: TrainingFileMesg.manufacturerFieldNum, value: value.rawValue)
	}

	public func getProduct() -> UInt16? {
		guard let value = getFieldValue(fieldNum: TrainingFileMesg.productFieldNum, index:0) as? UInt16 else {
            return nil
        }
		return value
	}

	public func setProduct(_ value: UInt16) throws {
		try setFieldValue(fieldNum: TrainingFileMesg.productFieldNum, value: value)
	}

	public func getFaveroProduct() throws -> FaveroProduct? {
		guard let value = try getFieldValue(fieldNum: TrainingFileMesg.productFieldNum, index: 0, subFieldIndex: ProductSubField.faveroProduct).map({UInt16(fitValue: $0)}) else {
			return nil
		}
		
		return FaveroProduct(rawValue: value) ?? .invalid
	}

	public func setFaveroProduct(_ value: FaveroProduct) throws {
		try setFieldValue(fieldNum: TrainingFileMesg.productFieldNum, value: value.rawValue, index: 0, subFieldIndex: ProductSubField.faveroProduct )
	}

	public func getGarminProduct() throws -> GarminProduct? {
		guard let value = try getFieldValue(fieldNum: TrainingFileMesg.productFieldNum, index: 0, subFieldIndex: ProductSubField.garminProduct).map({UInt16(fitValue: $0)}) else {
			return nil
		}
		
		return GarminProduct(rawValue: value) ?? .invalid
	}

	public func setGarminProduct(_ value: GarminProduct) throws {
		try setFieldValue(fieldNum: TrainingFileMesg.productFieldNum, value: value.rawValue, index: 0, subFieldIndex: ProductSubField.garminProduct )
	}

	public func getSerialNumber() -> UInt32? {
		guard let value = getFieldValue(fieldNum: TrainingFileMesg.serialNumberFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return value
	}

	public func setSerialNumber(_ value: UInt32) throws {
		try setFieldValue(fieldNum: TrainingFileMesg.serialNumberFieldNum, value: value)
	}

	public func getTimeCreated() -> DateTime? {
		guard let value = getFieldValue(fieldNum: TrainingFileMesg.timeCreatedFieldNum, index:0) as? UInt32 else {
            return nil
        }
		return DateTime(timestamp: value)
	}

	public func setTimeCreated(_ value: DateTime) throws {
		try setFieldValue(fieldNum: TrainingFileMesg.timeCreatedFieldNum, value: value.timestamp)
	}

	public class func createTrainingFileMesg() -> TrainingFileMesg {
        let mesg = TrainingFileMesg(name: "TrainingFile", num: Profile.MesgNum.trainingFile)
		
		mesg.fields[TrainingFileMesg.timestampFieldNum] = Field(name: "Timestamp", num: TrainingFileMesg.timestampFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[TrainingFileMesg.typeFieldNum] = Field(name: "Type", num: TrainingFileMesg.typeFieldNum, type: BaseType.ENUM.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[TrainingFileMesg.manufacturerFieldNum] = Field(name: "Manufacturer", num: TrainingFileMesg.manufacturerFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[TrainingFileMesg.productFieldNum] = Field(name: "Product", num: TrainingFileMesg.productFieldNum, type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
        mesg.fields[TrainingFileMesg.productFieldNum]?.subFields.append(SubField(name: "FaveroProduct", type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: ""))
        mesg.fields[TrainingFileMesg.productFieldNum]?.subFields[Int(ProductSubField.faveroProduct)].addMap(refFieldNum: 1, refFieldValue: 263)
        mesg.fields[TrainingFileMesg.productFieldNum]?.subFields.append(SubField(name: "GarminProduct", type: BaseType.UINT16.rawValue, scale: 1, offset: 0, units: ""))
        mesg.fields[TrainingFileMesg.productFieldNum]?.subFields[Int(ProductSubField.garminProduct)].addMap(refFieldNum: 1, refFieldValue: 1)
        mesg.fields[TrainingFileMesg.productFieldNum]?.subFields[Int(ProductSubField.garminProduct)].addMap(refFieldNum: 1, refFieldValue: 15)
        mesg.fields[TrainingFileMesg.productFieldNum]?.subFields[Int(ProductSubField.garminProduct)].addMap(refFieldNum: 1, refFieldValue: 13)
        mesg.fields[TrainingFileMesg.productFieldNum]?.subFields[Int(ProductSubField.garminProduct)].addMap(refFieldNum: 1, refFieldValue: 89)
		mesg.fields[TrainingFileMesg.serialNumberFieldNum] = Field(name: "SerialNumber", num: TrainingFileMesg.serialNumberFieldNum, type: BaseType.UINT32Z.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
		mesg.fields[TrainingFileMesg.timeCreatedFieldNum] = Field(name: "TimeCreated", num: TrainingFileMesg.timeCreatedFieldNum, type: BaseType.UINT32.rawValue, scale: 1, offset: 0, units: "", accumulated: false)
        return mesg
    }
}